clear
clc
%% Definitions and Parameters
bench = 'Benchmarks.xlsx';
benchsel = 5;
FM =  xlsread(bench,benchsel);
FM = FM';
c = length(FM(1,:));             % Column Size
r = length(FM(:,1));             % Row Size
std = 20;                        % Standard deviation of delay value
mu = 100;                        % Expected mean delay value
VM = zeros(r,c);
%% Loop for Generating VM
for i = 1 : c       
    for  j = 1 : r
        VM(j,i) = normrnd(mu,std);      % Generating VM
    end
end
perf_RAND = max(sum(VM.*FM));          % Performance of random mapping
%% Lower bound (lb) calculation
SS = unique(sort(sum(FM)));
Lows = SS(end);
for i = 1 : c
    RR(:,i) = sort(VM(:,i));
    L(i) = sum(RR(1:Lows,i));
end
lb = min(L);
%% Genetic Algorithm
MRate = 5*2;                                    % Mutation rate
GAInitPop = 500;                                % Initial population size
TournamentSize = GAInitPop/10;                  % Size of each tournament selection
EliminationTrialNum = GAInitPop*2;              % Elimination count
tic                                             % Timer starts
[ParentRow] = PopGenerate1D(GAInitPop,r);       % Initial population generation
for i = 1 : EliminationTrialNum
    [parent1M, parent2M, parentelim1M, parentelim2M] = TournamentRow(TournamentSize, VM, FM, ParentRow, r);     % Tornament selection
    [Cr1, Cr2] = CrossoverDefRow(r, ParentRow, parent1M, parent2M);                                             % Crossover between parents
    [Cr1, Cr2] = MutationDefRow(MRate, r, Cr1, Cr2);                                                            % Mutation on childs
    [ParentRow] = ChildReplace2PopRow(ParentRow, parentelim1M, parentelim2M, Cr1, Cr2);                         % Replacing worse parents with children
end
[FitnsM] = fitnessPopRow(VM, ParentRow, FM, r); % Worst-case delays for each parent on final population
GAout = min(FitnsM);                            % Lowest worst-case delay value of all population
devRateGenetic = (GAout-lb)/lb                  % Deviation rate from lower bound
time_GA1D = toc                                 % Runtime output






