clear
clc

%% Definitions and Parameters
bench = 'Benchmarks.xlsx';
benchsel = 1;
FM =  xlsread(bench,benchsel);
FM = FM';
c = length(FM(1,:));             % Column Size
r = length(FM(:,1));             % Row Size
std = 20;                        % Standard deviation of delay value
mu = 100;                        % Expected mean delay value
VM = zeros(r,c);
%% Loop for Generating VM
for i = 1 : c       
    for  j = 1 : r
        VM(j,i) = normrnd(mu,std);      % Generating VM
    end
end
perf_RAND = max(sum(VM.*FM));          % Performance of random mapping
%% Greedy Column Ordering
tic
for y = 1 : length(VM(1,:))
    VMLH(:,y) = sort(VM(:,y));                    % Low to high ordered VM
end
for i = 1 : length(FM(1,:))
    for j = 1 : length(VM(1,:))
    PMins(i,j) = sum(VMLH(1:sum(FM(:,i)),j));     % Minimum possible value of FM column 'i' on VM column 'j'
    end
end
PMXn = PMins;
PMXn(:,end+1) = 1 : length(PMins(:,1));
PMXn = flipud(sortrows(PMXn));
Mapng = 1:length(FM(1,:));
for i = 1 : length(FM(1,:))                       % Loop to find column matches
    [mx, pos] = min(PMXn(i,1:end-1));
    Mapng(2,PMXn(i,end)) = pos;
    PMXn(:,pos) = mx*1000;
end
newOrder = sortrows(fliplr(Mapng'))';                % New column ordering
FMc = FM;
for i = 1 : length(FM(1,:))                     
    FMc(:,i) = FM(:,newOrder(2,i));                  % New FM construction as FMc
end
time_SORT = toc;
Neworder = newOrder(2,:)