clear
clc
%% Definitions and Parameters
bench = 'Benchmarks.xlsx';
benchsel = 5;
FM =  xlsread(bench,benchsel);
FM = FM';
c = length(FM(1,:));             % Column Size
r = length(FM(:,1));             % Row Size
std = 20;                        % Standard deviation of delay value
mu = 100;                        % Expected mean delay value
VM = zeros(r,c);
%% Loop for Generating VM
for i = 1 : c       
    for  j = 1 : r
        VM(j,i) = normrnd(mu,std);      % Generating VM
    end
end
perf_RAND = max(sum(VM.*FM));          % Performance of random mapping
%% Lower bound (lb) calculation
SS = unique(sort(sum(FM)));
Lows = SS(end);
for i = 1 : c
    RR(:,i) = sort(VM(:,i));
    L(i) = sum(RR(1:Lows,i));
end
lb = min(L);
%% Random Solution Generation
population = 200;                                                           % Different ordering solutions of rows and columns
tic                                                                     % Timer starts
[ParentRow, ParentCol] = PopGenerate(population,r,c);                       % Generation random permutations
[FitnsM] = TestCurrentGen(ParentRow, ParentCol, FM, r, c, VM);          % Worst-case delays of each (row x column) solution
PROBout = min(nonzeros(FitnsM));                                        % Lowest achieved delay value of all solutions
devRateRandom = (PROBout-lb)/lb                                         % Deviation rate from lower bound
time_RAND = toc                                                         % Runtime output